'Rip Meedio Weather SQLite database

Option Explicit
On Error Resume Next

Dim Action
Dim objDB
Dim Status
Dim LocationNr
Dim arrLocations()
Dim tagDate
Dim tagTemp
Dim tagTempHi
Dim tagTempLow
Dim tagAsOf
Dim tagBarPressure
Dim tagRain
Dim tagDesc
Dim tagDewPoint
Dim tagFeelsLike
Dim tagHumidity
Dim tagVisibility
Dim tagWindDirDesc
Dim tagWindDir
Dim tagWindSpeed

Const MaxLocations = 3


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
Set objDB      = CreateObject("newObjects.sqlite.dbutf8")
objDB.AutoType = True
LocationNr     = 1
Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\weather.mlf")
Call Set_Tags(objDB)
objDB.Close

Do
	Sleep 1
	Action = GetPropertyValue ("Weather.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Weather.Action", "Waiting"
		Sleep 100
		If Action <> "" Then
			Status = ""
			Call Handle_WeatherAction(objDB, Action)
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "Weather.Status", Status
		End If
	End If
Loop

Set objDB = Nothing


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_WeatherAction(objDB, Action)
Dim objRow
Dim Data

	Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\weather.mlf")
	Call Get_Locations(objDB)
	Set objRow = objDB.Execute("SELECT * FROM items WHERE item_name = '" & arrLocations(LocationNr) & "'")
	Data = Split(Action, "_")

	Select Case Data(0)
		Case "Refresh" : Call Refresh_Weather(objDB, objRow)
		Case "Get Day" : Call Set_WeatherDay(objRow, CInt(Data(1))) 'Data(1) = 1 .. 8
		Case "Location": Call Set_Location(objDB, CInt(Data(1)))    'Location can be 1, 2, 3 etc etc
	End Select

	Set objRow = Nothing
	objDB.Close
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Refresh_Weather(objDB, objRow)
Dim nit
Dim Image_Path

	Call Set_Tags(objDB)
	
	'Keep images in separate directory because Meedio locks all used images.
	Image_Path = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Weather\"
        
	For nit = 1 To 8
		If nit <= objRow.Count Then
			SetPropertyValue "Weather.Image Day " & nit, Image_Path & objRow(nit)("item_image") & ".png"
			SetPropertyValue "Weather.Text Day "  & nit, Translate_DayName(objRow(nit)(tagDate))
		Else
			SetPropertyValue "Weather.Image Day " & nit, Image_Path & "cw_no_report_icon.png"
			SetPropertyValue "Weather.Text Day "  & nit, ""
		End If
	Next
	
	Call Set_WeatherDay(objRow, 1) 'Current Day from Location
	SetPropertyValue "Weather.Selected Day", Translate_DayName(objRow(1)(tagDate))
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_WeatherDay(objRow, DayNr)
Dim nit
Dim Wind
	
	If DayNr <= objRow.Count Then
		SetPropertyValue "Weather.Selected Day", Translate_DayName(objRow(DayNr)(tagDate))
		SetpropertyValue "Weather.Location",    Get_Item(objRow, DayNr, "item_name")
		SetpropertyValue "Weather.Update",      Get_Item(objRow, DayNr, tagAsOf)
		SetpropertyValue "Weather.Pressure",    Get_Item(objRow, DayNr, tagBarPressure) & " mb"
		SetpropertyValue "Weather.Rain",        Get_Item(objRow, DayNr, tagRain)        & "%"
		SetpropertyValue "Weather.Description", Get_Item(objRow, DayNr, tagDesc)    
		SetpropertyValue "Weather.Dewpoint",    Get_Item(objRow, DayNr, tagDewPoint)    & "C"
		SetpropertyValue "Weather.Feels Like",  Get_Item(objRow, DayNr, tagFeelsLike)   & "C"
		SetpropertyValue "Weather.Humidity",    Get_Item(objRow, DayNr, tagHumidity)    & "%"
		SetpropertyValue "Weather.Visibility",  Get_Item(objRow, DayNr, tagVisibility)  & " Km"
		SetpropertyValue "Weather.Temp Day 1",  Get_Item(objRow, 1, tagTemp)            & "C"
		Wind = Get_Item(objRow, DayNr, tagWindDirDesc) & " " & Get_Item(objRow, DayNr, tagWindDir) & " - " & Get_Item(objRow, DayNr, tagWindSpeed) & " Km/u"
		SetpropertyValue "Weather.Wind", Wind
		
		If DayNr = 1 Then
			SetpropertyValue "Weather.Temperature", Get_Item(objRow, DayNr, tagTemp) & "C"
		Else
			SetpropertyValue "Weather.Temperature", Get_Item(objRow, DayNr, tagTempLow) & " / " & Get_Item(objRow, DayNr, tagTempHi) & "C"
		End If
	Else
		Status = "No data for selected day!"
	End If
	
	For nit = 2 to 8
		If nit <= objRow.Count Then
			SetpropertyValue "Weather.Temp Day " & nit, Get_Item(objRow, nit, tagTempLow) & " / " & _
		        	                                    Get_Item(objRow, nit, tagTempHi) & "C"
		Else
			SetpropertyValue "Weather.Temp Day " & nit, ""
		End If
	Next
End Sub 
        

'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Location(objDB, LocNr)
Dim objRow

	If arrLocations(LocNr) <> "" Then
		LocationNr = locNr
		Set objRow = objDB.Execute("SELECT * FROM items WHERE item_name = '" & arrLocations(LocationNr) & "'")
		Call Refresh_Weather(objDB, objRow)
		Set objRow = Nothing
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Get_Locations(objDB)
Dim objRow
Dim nit

	Set objRow = objDB.Execute("SELECT DISTINCT item_name FROM items")
	
	If objRow.Count > 0 Then
		ReDim arrLocations(objRow.Count + 1)
		
		For nit = 1 To objRow.Count
			arrLocations(nit) = objRow(nit)("item_name")
		Next
	Else
		Status = "No Locations found"
	End If
	
	For nit = 1 To MaxLocations
		SetPropertyValue "Weather.Location " & nit, arrLocations(nit)
	Next			
	
	Set objRow = Nothing
End Sub


'-------------------------------------------------------
'- Set all Tag names -> Global variables ---------------
'-------------------------------------------------------
Sub Set_Tags(objDB)
	
	tagDate        = Get_Tag("date")
	tagTemp        = Get_Tag("temp")
	tagTempHi      = Get_Tag("temp-hi")
	tagTempLow     = Get_Tag("temp-low")
	tagAsOf        = Get_Tag("as-of")
	tagBarPressure = Get_Tag("bar-pressure")
	tagRain        = Get_Tag("rain")
	tagDesc        = Get_Tag("desc")
	tagDewPoint    = Get_Tag("dew-point")
	tagFeelsLike   = Get_Tag("feels-like")
	tagHumidity    = Get_Tag("humidity")
	tagVisibility  = Get_Tag("visibility")
	tagWindDirDesc = Get_Tag("wind-dir-desc")
	tagWindDir     = Get_Tag("wind-dir")
	tagWindSpeed   = Get_Tag("wind-speed")
End Sub


'-------------------------------------------------------
'- Sub Function called from Get_Tag --------------------
'-------------------------------------------------------
Function Get_Tag(tagName)
Dim objRow
Dim tagValue

	Get_Tag    = "--"
	Set objRow = objDB.Execute("SELECT * FROM tags WHERE tag_name = '" & tagName & "'")

	If objRow.Count > 0 Then
		If IsNull(objRow(1)("tag_col")) = False Then
			tagValue = objRow(1)("tag_col")
			If tagValue <> "" Then
				Get_Tag = tagValue
			End If
		End If
	End If
	
	Set objRow = Nothing
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Get_Item(objRow, DayNr, ItemLabel)
Dim Itemvalue

	If IsNull(objRow(DayNr)(ItemLabel)) = False Then
		ItemValue = objRow(DayNr)(ItemLabel)
		If ItemValue <> "" Then
			Get_Item = ItemValue
		Else
			Get_Item = "--"
		End If
	Else
		Get_Item = "--"
	End If
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Translate_DayName(DayName)
Dim Data

	Select Case DayName
		Case "Today"    : Data = "Actueel"
		Case "Sunday"   : Data = "Zondag"
		Case "Monday"   : Data = "Maandag"
		Case "Tuesday"  : Data = "Dinsdag"
		Case "Wednesday": Data = "Woensdag"
		Case "Thursday" : Data = "Donderdag"
		Case "Friday"   : Data = "Vrijdag"
		Case "Saturday" : Data = "Zaterdag"
		Case Else       : Data = "Onbekend"
	End Select
	
	Translate_DayName = Data
End Function
